From 1389bb26b55cf2bb05b252f494489dd252d7b5df Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Sep 28 2017 17:35:09 +0000
Subject: [PATCH 955/1001] Widget add and config panels are now React-based


---

diff --git a/hubs/models.py b/hubs/models.py
index 498d4fa..55530f9 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -458,9 +458,6 @@ class Widget(ObjectAuthzMixin, BASE):
     def module(self):
         return hubs.widgets.registry[self.plugin]
 
-    @property
-    def edit_url(self):
-        return self.module.get_edit_url(self.hub, self)
 
     @property
     def enabled(self):
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index b562662..698f34d 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -202,45 +202,6 @@ class Widget(object):
                     self.name, url_rule.lstrip("/"))
                 app.add_url_rule(rule, view_func=view_func)
 
-    def get_add_url(self, hub, position):
-        """Returns the URL to the configuration panel to add this widget.
-
-        By default, it returns the URL to the common widget configuration panel
-        that will simply display the widget's parameters in a form.  Widgets
-        override this method to implement a more complex configuration view.
-
-        If a more complex configuration view is implemented, the resulting HTML
-        code will be wrapped in a ``<div class="modal-dialog">`` tag.
-
-        Args:
-            hub (hubs.models.Hub): The hub instance in the database.
-            position (str): the position where the widget should be added. It
-                must be either ``left`` or ``right``, and must be in the
-                supported positions for this widget (see :py:attr:`position`).
-
-        Returns:
-            The URL to add this widget, as a string.
-        """
-        return "%s?position=%s" % (
-            flask.url_for('widget_add', hub=hub.name, widget=self.name),
-            position)
-
-    def get_edit_url(self, hub, widget_instance):
-        """Returns the URL to the configuration panel to edit this widget.
-
-        This method works like :py:meth:`get_add_url`.
-
-        Args:
-            hub (hubs.models.Hub): The hub instance in the database.
-            widget_instance (hubs.models.Widget): The widget instance in the
-                database that must be configured.
-
-        Returns:
-            The URL to edit this widget, as a string.
-        """
-        return flask.url_for(
-            'widget_edit', hub=hub.name, idx=widget_instance.idx)
-
     def get_cached_functions(self):
         """
         Returns:
diff --git a/hubs/widgets/halp/__init__.py b/hubs/widgets/halp/__init__.py
index 47b47fb..741b1e6 100644
--- a/hubs/widgets/halp/__init__.py
+++ b/hubs/widgets/halp/__init__.py
@@ -6,7 +6,7 @@ import flask
 
 from hubs.widgets.base import Widget
 from hubs.widgets import validators
-from .views import add_view, hubs_suggest_view
+from .views import hubs_suggest_view
 
 
 class Halp(Widget):
@@ -43,20 +43,8 @@ class Halp(Widget):
         env.filters['humanize'] = lambda d: arrow.get(d).humanize()
         return env
 
-    def get_add_url(self, hub, position):
-        return "%s?position=%s" % (
-            flask.url_for('halp_config_add', hub=hub.name), position)
-
-    def get_edit_url(self, hub, widget_instance):
-        return flask.url_for(
-            'halp_config', hub=hub.name, idx=widget_instance.idx)
-
     def register_routes(self, app):
         super(Halp, self).register_routes(app)
-        # Add the widget add view
-        rule = "/<hub>/w/%s/add" % self.name
-        endpoint = "%s_config_add" % self.name
-        app.add_url_rule(rule, endpoint=endpoint, view_func=add_view)
         # Add the hubs suggestion view
         rule = "/w/%s/hubs" % self.name
         endpoint = "%s_config_hubs" % self.name
diff --git a/hubs/widgets/halp/views.py b/hubs/widgets/halp/views.py
index a00ad6e..dfd1e30 100644
--- a/hubs/widgets/halp/views.py
+++ b/hubs/widgets/halp/views.py
@@ -140,27 +140,6 @@ class RequestersView(WidgetView):
         return {"results": results}
 
 
-class ConfigView(WidgetView):
-    """
-    The custom configuration panel.
-    """
-
-    name = "config"
-    url_rules = ["config"]
-    template_name = "halp_config.html"
-    permission = "config"
-
-    def get_context(self, instance, *args, **kwargs):
-        post_url = flask.url_for(
-            'widget_edit', hub=instance.hub.name, idx=instance.idx)
-        initial = instance.config.copy()
-        return dict(
-            mode="edit",
-            url=post_url,
-            initial=initial,
-            )
-
-
 def hubs_suggest_view():
     """
     Returns suggestions for the "hubs" list in the configuration.
@@ -172,36 +151,3 @@ def hubs_suggest_view():
             "%s%%" % flask.request.args.get("q")))
     results = results.order_by(Hub.name)[:MAX_SUGGESTS]
     return flask.jsonify({"results": [h.name for h in results]})
-
-
-@require_hub_access("config", url_param="hub")
-def add_view(hub):
-    """The custom configuration panel when adding the widget.
-
-    This is not a subclass of WidgetView because it is not specific
-    to a widget instance, therefore it does not have the same URL
-    parameters.
-    """
-    hub = get_hub(hub)
-    widget = registry["halp"]
-    tpl_env = widget.get_template_environment()
-    template = tpl_env.get_template("halp_config.html")
-    post_url = "%s?position=%s" % (
-        flask.url_for('widget_add', hub=hub.name, widget="halp"),
-        flask.request.args.get("position"))
-    initial = dict(
-        (param.name, param.default)
-        for param in widget.get_parameters()
-        )
-    initial["hubs"] = [hub.name]
-    context = dict(mode="add", url=post_url, initial=initial)
-    # Mimic flask.templating._render(). Too bad it's not a public API.
-    if before_render_template is not None:
-        before_render_template.send(
-            flask._app_ctx_stack.top.app,
-            template=template, context=context)
-    output = template.render(**context)
-    template_rendered.send(
-        flask._app_ctx_stack.top.app,
-        template=template, context=context)
-    return output

